<?php
/**
 * Description of colorpicker
 *
 * @package     Expose
 * @version     1.0  
 * @author      ThemeXpert http://www.themexpert.com
 * @copyright   Copyright (C) 2010 - 2011 ThemeXpert
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 * @filesource
 * @file        colorpicker.php
 **/
defined('JPATH_BASE') or die;

class JElementColorPicker extends JElement{

    var $_name = 'ColorPicker';

    function fetchElement($name, $value, &$node, $control_name){
        global $expose;
        $output = NULL;
        
        if(!defined('EXPOSE_COLOR_PICKER')){
            define('EXPOSE_COLOR_PICKER', 1);
            $expose->addScript($expose->exposeUrl.'admin/widgets/colorpicker/js/colorpicker.js');
        }

        $class = $node->attributes('class') ? ' class="'.(string) $node->attributes('class').'"' : '';
        $picker = $control_name.$name.'_picker';
        
        $js = "
            $('#$picker').ColorPicker({
                color: '{$value}',
                onShow: function (colpkr) {
                    $(colpkr).fadeIn(500);
                    return false;
                },
                onHide: function (colpkr) {
                    $(colpkr).fadeOut(500);
                    return false;
                },
                onChange: function (hsb, hex, rgb) {
                    $('#$picker div').css('backgroundColor', '#' + hex);
                    $('#$control_name$name').val(hex);
                    $('#$control_name$name').parent().addClass('highlight');
                },
                onSubmit: function(hsb, hex, rgb, el) {
                    $(el).val(hex);
                    $(el).ColorPickerHide();
                }

            });";
        //should be declear from base class addInlineScript();
        //$expose->doc->addScriptDeclaration($js);
        $expose->addjQDom($js);
        
        $output .= '<input class="picker '.$class.'" type="text" name="'.$control_name.'['.$name.']" id="'.$control_name.$name.'"' .
                   ' value="'.htmlspecialchars($value, ENT_COMPAT, 'UTF-8').'"' . '/>';
        $output .= '<div id="'.$control_name.$name.'_picker" class="color-selector"><div style="background-color:#'.$value.'"></div></div>';
        return $output;
    }
}

