<?php
/**
 * @package     Expose
 * @version     1.0
 * @author      ThemeXpert http://www.themexpert.com
 * @copyright   Copyright (C) 2010 - 2011 ThemeXpert
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 * @filesource
 * @file        slider.php
 **/
defined('JPATH_BASE') or die;

class JElementSlider extends JElement{

    var $_name = 'Slider';

    function fetchElement($name, $value, &$node, $control_name){
        global $expose;
        $output = NULL;

        // Initialize some field attributes.
        $class		= (string) $node->attributes('class');
        $disabled	= ((string) $node->attributes('disabled') == 'true') ? ' disabled="disabled"' : '';
        $min            = $node->attributes('min') ? (int)$node->attributes('min') : 0;
        $max            = $node->attributes('max') ? (int)$node->attributes('max') : 100;
        $pretext        = ($node->attributes('pretext') != NULL) ? '<span class="pre-text hasTip" title="'. JText::_(($node->attributes('pre-desc')) ? $node->attributes('pre-desc') : $node->attributes('description')) .'">'.(string)$node->attributes('pretext').'</span>' : '';
        $posttext       = ($node->attributes('posttext') != NULL) ? '<span class="post-text">'.(string)$node->attributes('posttext').'</span>' : '';

        $wrapstart  = '<div class="slider-wrap clearfix '.$class.'">';
        $wrapend    = '</div>';

        if(!defined('EXPOSE_SLIDER')){
            define('EXPOSE_SLIDER', 1);
            $js = '$(".slider-input").rangeinput({ progress: true });';
            $expose->addjQDom($js);
        }

        $input = '<input class="slider-input" type="text" min="'.$min.'" max="'.$max.'" name="'.$control_name.'['.$name.']" id="'.$control_name.$name.'"' .
				' value="'.$value.'"' .
				$disabled.'/>';

        return $output = $wrapstart . $pretext . $input . $posttext . $wrapend;
    }

}
