<?php
/**
 * @package     Expose
 * @version     1.0
 * @author      ThemeXpert http://www.themexpert.com
 * @copyright   Copyright (C) 2010 - 2011 ThemeXpert
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 * @filesource
 * @file        text.php
 **/
defined('JPATH_BASE') or die;

class JElementText extends JElement
{
	var $_name = 'Text';

        function fetchElement($name, $value, &$node, $control_name){
            $output = NULL;
            // Initialize some field attributes.
            $size		= ( $node->attributes('size') ? 'size="'.$node->attributes('size').'"' : '' );
            $maxLength	= $node->attributes('maxlength') ? ' maxlength="'.(int) $node->attributes('maxlength').'"' : '';
            $class      = $node->attributes('class');
            $readonly	= ((string) $node->attributes('readonly') == 'true') ? ' readonly="readonly"' : '';
            $disabled	= ((string) $node->attributes('disabled') == 'true') ? ' disabled="disabled"' : '';
            
            $pretext        = ($node->attributes('pretext') != NULL) ? '<span class="pre-text hasTip" title="'. JText::_(($node->attributes('pretext')) ? $node->attributes('pre-desc') : '') .'">'.(string)$node->attributes('pretext').'</span>' : '';
            $posttext       = ($node->attributes('posttext') != NULL) ? '<span class="post-text">'.(string)$node->attributes('posttext').'</span>' : '';

            $wrapstart  = '<div class="field-wrap clearfix '.$class.'">';
            $wrapend    = '</div>';

            $input = '<input type="text" name="'.$control_name.'['.$name.']" id="'.$control_name.$name.'"' .
                            ' value="'.$value.'"' .
                            $size.$disabled.$readonly.$maxLength.'/>';

            $output = $wrapstart . $pretext . $input . $posttext . $wrapend;
         
            return $output;
	}

}



