/**
 * @package     Expose
 * @version     1.0
 * @author      ThemeXpert http://www.themexpert.com
 * @copyright   Copyright (C) 2010 - 2011 ThemeXpert
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 * @filesource
 * @file        expose.js
 **/

jQuery.noConflict();

jQuery(window).ready(function($){
   $.blockUI({ 
        message: '<h1>Please Wait...</h1>',
        timeout: 2000
   });

    //create basic html skeliton for admin
    $('#element-box div.m form').append(
        '<div id="expose-wrapper" class="clearfix"><div class="expose-details clearfix"></div><div class="expose-tab-wrapper clearfix"><div class="expose-tab"><ul></ul></div><div class="expose-tab-content"></div></div></div>'
    );

    //loop through all h3 element and convert them to expose tab
    $('h3.title').each(function(){
        //lets cache some vaue
        var obj = $(this);
        var title = $(this).text(); // this title will use as class name

        $('<li><span>'+ title +'</span></li>').appendTo('.expose-tab ul').addClass(title);
        obj.next().removeClass().removeAttr('style').addClass(function(){
            if(title == 'assignments'){
                $(this).empty();
            }
            return 'panel ' + title + ' clearfix';
        }).appendTo('.expose-tab-content');
        //$(this).remove();
    });
    
    //finally remove the parent div of all accordion
    $('.width-50:last').remove();

    //lets insert template info input boxes to expose-details.
    $('.width-50:first').appendTo('.expose-details').removeClass('width-50 fltlft').addClass('expose-inner');

    //lets take the menu assingments div and append it to its own div under tab
    $('.expose-details .adminform:last').appendTo('div.assignments');

    //remove old parent div
    //$('.width-60').remove();

    //lets remove template details label
    $('.expose-details tr:last td:first').remove();

    //now move the template description to expose-wrapper
    $('.expose-details tr:last').appendTo('#expose-wrapper');

    //take remove-lbl class and align them to each
    $('.remove-lbl').each(function(){
        $(this).parent().prev().remove();
        var content = $(this).parent();
        var prevrow = content.parent().prev();
        content.parent().remove();
        content.appendTo(prevrow);
    });
    $('.expose-spacer').each(function(){
       var content = $(this);
       content.parent().prev().remove();
       content.parent().attr('colspan','6');
       //content.parent().parent().replaceWith(content);
    });

    $('<div class="clear"></div>').appendTo('.panel li');

    $('select,input,.handle,textarea,radio').change(function(){
        $(this).parent().addClass('highlight');
    });

    $(".toggle").exposeToggle();
    $('.toggleContainer').click(function(){
        var box = $(this).find('input:checkbox');
        var id = 'params' + box.attr('id');
        ($('#'+ id).attr('value') == 0) ? $('#'+id).attr('value',1) : $('#'+id).attr('value',0);
    });

    $('.overlay-trigger').overlay({
        mask: {
		color: '#000',
		loadSpeed: 200,
		opacity: 0.5
	}
    });
         
    //initiate tab class
    $('.expose-tab ul').tabs('.expose-tab-content > .panel',{
        effect: 'fade'
    });
});
